## CHAPTER 1 - INTRODUCTION

Beneath Apple DOS is intended to serve as a companion to Apple's DOS Manual,
providing additional information for the advanced programmer or the novice Apple
user who wants to know more about the structure of diskettes.  It is not the
intent of this manual to replace the documentation provided by Apple Computer
Inc.  Although, for the sake of continuity, some of the material covered in the
Apple manual is also covered here, it will be assumed that the reader is
reasonably familiar with the contents of the DOS Manual.  Since all chapters
presented here may not be of use to each Apple owner, each has been written to
stand on its own.

The information presented here is a result of intensive disassembly and
annotation of various versions of DOS by the authors and by other experienced
systems programmers.  It also draws from application notes, articles, and
discussions with knowledgeable people.  This manual was not prepared with the
assistance of Apple Computer Inc.  Although no guarantee can be made concerning
the accuracy of the information presented here, all of the material included in
Beneath Apple DOS has been thoroughly researched and tested.

There were several reasons for writing Beneath Apple DOS:

- To show direct assembly language access to DOS.
- To help you to fix clobbered diskettes.
- To correct errors and omissions in the Apple documentation.
- To allow you to customize DOS to fit your needs.
- To provide complete information on diskette formatting.

![](artwork/1-01_reasons.png)

When Apple Computer Inc. introduced its Disk Operating System (DOS) version 3 in
1978 to support the new DISK II drive, very little documentation was provided.
Later, when DOS 3.2 was released, a 178 page instructional and reference manual
became available covering the use of DOS from BASIC in depth and even touched
upon some of the internal workings of DOS.  With the advent of DOS 3.3, the old
3.2 manual was updated but the body of information in it remained essentially
intact.  Beyond these Apple manuals, there have been no significant additions to
the documentation on DOS, apart from a few articles in APPLE user group
magazines and newsletters.  This manual takes up where the Disk Operating System
Manual leaves off.

Throughout this manual, discussion centers primarily on DOS version 3.3.  The
reasons for this are that 3.3 was the most recent release of DOS at the time of
this writing and that it differs less from DOS 3.2 than one would imagine.
Wherever there is a major difference between the various DOS releases in a given
topic, each release will be covered.

In addition to the DOS dependent information provided, many of the discussions
also apply to other operating systems on the Apple II and Apple III.  For
example, disk formatting at the track and sector level is, for the most part,
the same.
